# coding: utf-8

"""
    Cobo Wallet as a Service 2.0

    Contact: help@cobo.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from cobo_waas2.models.wallet_type import WalletType
from typing import Optional, Set
from typing_extensions import Self


class BookkeepingRecord(BaseModel):
    """
    The bookkeeping item information.
    """  # noqa: E501
    wallet_id: StrictStr = Field(description="The wallet ID.")
    wallet_type: Optional[WalletType] = None
    wallet_name: Optional[StrictStr] = Field(default=None, description="The wallet name.")
    transaction_timestamp: StrictInt = Field(description="The time when the bookkeeping was created, in Unix timestamp format, measured in milliseconds.")
    token_id: StrictStr = Field(description="The token ID, which is the unique identifier of a token. You can retrieve the IDs of all the tokens you can use by calling [List enabled tokens](/v2/api-references/wallets/list-enabled-tokens).")
    type: StrictStr = Field(description="The bookkeeping type.")
    amount: StrictStr = Field(description="The amount of the bookkeeping.")
    balance: StrictStr = Field(description="The post-balance of the tx.")
    from_address: Optional[StrictStr] = Field(default=None, description="The from address.")
    to_address: Optional[StrictStr] = Field(default=None, description="The to address.")
    transaction_hash: Optional[StrictStr] = Field(default=None, description="The transaction hash.")
    __properties: ClassVar[List[str]] = ["wallet_id", "wallet_type", "wallet_name", "transaction_timestamp", "token_id", "type", "amount", "balance", "from_address", "to_address", "transaction_hash"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BookkeepingRecord from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BookkeepingRecord from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "wallet_id": obj.get("wallet_id"),
            "wallet_type": obj.get("wallet_type"),
            "wallet_name": obj.get("wallet_name"),
            "transaction_timestamp": obj.get("transaction_timestamp"),
            "token_id": obj.get("token_id"),
            "type": obj.get("type"),
            "amount": obj.get("amount"),
            "balance": obj.get("balance"),
            "from_address": obj.get("from_address"),
            "to_address": obj.get("to_address"),
            "transaction_hash": obj.get("transaction_hash")
        })
        return _obj


